

// Fichier avec mes fonctions perso pour tout le programme !!!

// Classe KNs -> Kaid.fr.st
// (c) Kaid - kaid.fr.st
// Bien amlior par H.2.O (changemment expediteur, bug corriger, detection val retour, etc) :D
////////////////////////

#include "H2OFonctions.h"
#include "NetSenderForm.h"

#define STR_MESSENGER_SRV	"Messenger"
#define STR_SERVER		NULL
#define STR_FROMNAME		NULL       

// Envoi du message //
bool H2OFonctions::SendMessage(const std::string& strExpediteur, const std::string& strDestinataire, const std::string& strMessage)
{
	// Convertion des chaines en unicode
    WCHAR* wstrExpediteur = new WCHAR [strExpediteur.length() + 1];
	AsciiToUnicode(strExpediteur.c_str(), wstrExpediteur, strExpediteur.length() + 1);

	WCHAR* wstrDestinataire = new WCHAR [strDestinataire.length() + 1];
	AsciiToUnicode(strDestinataire.c_str(), wstrDestinataire, strDestinataire.length() + 1);

	WCHAR* wstrMessage = new WCHAR [strMessage.length() + 1];
	AsciiToUnicode(strMessage.c_str(), wstrMessage, strMessage.length() + 1);
       
    NetMessageNameAdd( NULL, wstrExpediteur );
    NetMessageNameAdd( NULL, wstrDestinataire );

	// Longueur du message en bytes
	int tMsg = (strMessage.length() + 1) * sizeof(WCHAR);

	NET_API_STATUS resNs = NetMessageBufferSend(STR_SERVER, wstrDestinataire, wstrExpediteur, reinterpret_cast<LPBYTE>(wstrMessage), tMsg);

    NetMessageNameDel( NULL, wstrExpediteur );
    NetMessageNameDel( NULL, wstrDestinataire );

	// Libration mmoire
    delete [] wstrExpediteur;
	delete [] wstrDestinataire;
	delete [] wstrMessage;

  switch( resNs )      // Analyse valeur de retour pour diagnostic approfondi
  {
  case ERROR_ACCESS_DENIED :
          H2ONetSender->StatusBar->Panels->Items[0]->Text = "Err: Vous n'avez pas l'accs pour l'envoi";
          MessageBeep( MB_ICONEXCLAMATION );
          H2ONetSender->Timer->Enabled = false;
          H2ONetSender->Timer->Enabled = true;
          return false;
  case ERROR_INVALID_PARAMETER :
          H2ONetSender->StatusBar->Panels->Items[0]->Text = "Err: Un des paramtres est invalide";
          MessageBeep( MB_ICONEXCLAMATION );
          H2ONetSender->Timer->Enabled = false;
          H2ONetSender->Timer->Enabled = true;
          return false;
  case ERROR_NOT_SUPPORTED :
          H2ONetSender->StatusBar->Panels->Items[0]->Text = "Err: Cette requte n'est pas supporte";
          MessageBeep( MB_ICONEXCLAMATION );
          H2ONetSender->Timer->Enabled = false;
          H2ONetSender->Timer->Enabled = true;
          return false;
  case NERR_NameNotFound :
          H2ONetSender->StatusBar->Panels->Items[0]->Text = "Err: L'alias du destinataire n'xiste pas";
          MessageBeep( MB_ICONEXCLAMATION );
          H2ONetSender->Timer->Enabled = false;
          H2ONetSender->Timer->Enabled = true;
          return false;
  case NERR_NetworkError :
          H2ONetSender->StatusBar->Panels->Items[0]->Text = "Err: Echec de la connexion !";
          MessageBeep( MB_ICONEXCLAMATION );
          H2ONetSender->Timer->Enabled = false;
          H2ONetSender->Timer->Enabled = true;
          return false;
  case NERR_Success :
          return true;
  default :
          H2ONetSender->StatusBar->Panels->Items[0]->Text = "Erreur inconnue ( %d )", resNs;
          MessageBeep( MB_ICONEXCLAMATION );
          H2ONetSender->Timer->Enabled = false;
          H2ONetSender->Timer->Enabled = true;
          return false;
  }
}
//---------------------------------------------------------------------------

// Retourne l'tat du service //
DWORD H2OFonctions::GetServiceStatus()
{
	// Ouverture de la base des services
	SC_HANDLE scManager=OpenSCManager(NULL, SERVICES_ACTIVE_DATABASE, GENERIC_READ);

	if (!scManager)
     return 0;

	// Ouverture du service
	SC_HANDLE scMessenger=OpenService(scManager, STR_MESSENGER_SRV, SERVICE_QUERY_STATUS);

	if (!scMessenger)
	{
		CloseServiceHandle(scManager);
    return 0;
	}
  
	// Rcupration de l'tat du service
	SERVICE_STATUS scStatus;
	if (!QueryServiceStatus(scMessenger, &scStatus))
	{
		CloseServiceHandle(scMessenger);
		CloseServiceHandle(scManager);
    return 0;
	}

	// Fermeture
	CloseServiceHandle(scMessenger);
	CloseServiceHandle(scManager);

	return scStatus.dwCurrentState;
}
//---------------------------------------------------------------------------

// Teste si le service de messagerie est dmarr //
BOOL H2OFonctions::IsServiceRunning()
{
	return ( GetServiceStatus() == SERVICE_RUNNING );
}
//---------------------------------------------------------------------------


// Conversion d'une chaine ASCII en chaine Unicode //
void H2OFonctions::AsciiToUnicode(LPCSTR asciiString, LPWSTR unicodeString, int t_unicodeString)
{
	MultiByteToWideChar(CP_ACP, 0, asciiString, -1, unicodeString, t_unicodeString);
}
//---------------------------------------------------------------------------


// Conversion d'une chaine unicode en chaine ASCII //
void H2OFonctions::UnicodeToAscii(LPCWSTR unicodeString, char* asciiString, int t_asciiString)
{
	WideCharToMultiByte(CP_ACP, 0, unicodeString, -1, asciiString, t_asciiString, NULL, NULL);
}
//---------------------------------------------------------------------------


// Fonction pour enumerer tout les ordinateurs du rseau
void __fastcall H2OFonctions::EnumNetRes(NETRESOURCE* nr)
{
        HANDLE hEnum;

        //NetResource = NULL : On enumere TOUTES les resources
        if( WNetOpenEnum( RESOURCE_GLOBALNET, RESOURCETYPE_ANY, RESOURCEUSAGE_CONTAINER, nr, &hEnum) != NO_ERROR )
        {                       // Error (acces interdit a cette instance)
                H2ONetSender->StatusBar->Panels->Items[0]->Text = "Impossible d'afficher la liste";
                MessageBeep( MB_ICONEXCLAMATION );
                H2ONetSender->Timer->Enabled = false;
                H2ONetSender->Timer->Enabled = true;
                return;         // Si on ne veut pas continuer l'enumeration
        }
                                // Enumeration de toutes les resources
        DWORD Count = -1;
        DWORD BufferSize = 0;
        DWORD ReturnVal = 0;                                // Allocation de l'espace pour le tableau des resources reso
        NETRESOURCE *NetRes = (NETRESOURCE*) new char[1024];
        ZeroMemory( NetRes, sizeof( NETRESOURCE ) );
        
        while(1)
        {
                ReturnVal = WNetEnumResource( hEnum, &Count, NetRes, &BufferSize );

                if( ReturnVal == ERROR_MORE_DATA )  // On recalcul la taille du Buffer
                {
                        Count = -1;
                        delete[] NetRes;
                        NetRes = ( NETRESOURCE* ) new char[ BufferSize ];
                        ZeroMemory( NetRes, sizeof( NETRESOURCE ) );
                        ReturnVal = WNetEnumResource( hEnum, &Count, NetRes, &BufferSize );
                }
                if(ReturnVal!=NO_ERROR)break;

                                     // Ajoute les resources ds la check list box
                char Tmp[100];
                for (unsigned int i=0;i<Count;i++)    // Verifie l'ensemble de toutes les resources trouver
                {
                        if ( ( NetRes[i].lpRemoteName[0] == '\\' ) && ( NetRes[i].lpRemoteName[1] == '\\' ) )
                        {                             // On prend ke celle comencant par '//' soit un ordinateur
                                for ( unsigned int j = 0, k = 2; j < strlen( NetRes[i].lpRemoteName ); j++, k++ )
                                        Tmp[j] = NetRes[i].lpRemoteName[k];

                                H2ONetSender->DestListe->Items->Add( Tmp );
                        }
                                // Necessite pour la recurrence et trouver lensemble des pc
                        if((NetRes[i].dwUsage & RESOURCEUSAGE_CONTAINER)==RESOURCEUSAGE_CONTAINER)
                                EnumNetRes(&NetRes[i]);

                }
                if( ReturnVal == ERROR_NO_MORE_ITEMS )
                {               //Terminus tous le monde descend
                        delete[] NetRes;
                        WNetCloseEnum( hEnum );
                } // A Voir lib mem
        }
        delete[] NetRes;
        WNetCloseEnum( hEnum );

        return;
}
//---------------------------------------------------------------------------

