

#ifndef __H2OFonctions_H__
#define __H2OFonctions_H__

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <lm.h>
#include <string>
#include <vector>

class H2OFonctions
{
public:

	// Envoi d'un message
	static bool SendMessage(const std::string& strExpediteur, const std::string& strDestinataire, const std::string& strMessage);

	// Etat du service
	static DWORD GetServiceStatus();
	static BOOL  IsServiceRunning();

        // Enumration des alias
        void static __fastcall EnumNetRes(NETRESOURCE* nr);

public:

	// Mthodes de conversion ASCII - Unicode
	static void AsciiToUnicode(LPCSTR asciiString, LPWSTR unicodeString, int t_unicodeString);
	static void UnicodeToAscii(LPCWSTR unicodeString, LPSTR asciiString, int t_asciiString);

private:
	H2OFonctions();
	~H2OFonctions();


public:

	// Classe d'exception
	class Exception
	{
	public:

		// Constructeur de copie
		Exception(const Exception& ex);
		
		// Rcupration du message d'erreur
		inline const std::string& errorMsg() const
		{
			return m_errorMsg;
		}

		// Rcupration du numro d'erreur
		inline DWORD errorNum() const
		{
			return m_errorNum;
		}


	protected:

		// Constructeur
		Exception(DWORD errorNum);

		// Attributs
		std::string m_errorMsg;
		DWORD		m_errorNum;

		friend class H2OFonctions;
	};
};


#endif // __H2OFonctions_H__