//---------------------------------------------------------------------------

#include <inifiles.hpp>
#include <vcl.h>
#pragma hdrstop

#include "Historique.h"
#include "NetSenderForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

THistoriqueForm *HistoriqueForm;
//---------------------------------------------------------------------------

struct fiche
{
        char DateTime[50];
        int NumMsg;                       // Rcupration valeur nombre message
        bool ChkMsg;                      // Bouton "Indiquer numro msg"
                                          //    Structure pour la gestion des fiches
        char Exp[32];                     // Rcupration de l'expediteur
        char Dest[32];                         // Rcupration du (des) destinataire(s)
        char msg[878];                    // Rcupration du mssage
};
bool EffAll = false;

__fastcall THistoriqueForm::THistoriqueForm(TComponent* Owner)
        : TForm(Owner)
{
        ColumnToSort = 0;

        struct fiche read;

        int fichier;
        TIniFile *Options = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

        if ( !FileExists( "Historique.log" ) )
                fichier = FileCreate( "Historique.log" );
        else
                fichier = FileOpen( "Historique.log", fmOpenRead );

        for(int j=0;j<Options->ReadInteger("Historique", "Max", 1000 );j++)
        {
                int TestStruct = FileRead( fichier, &read, sizeof( struct fiche ));

                if ( TestStruct == 0 )
                        break;

                TListItem  *ListItem;

                ListItem = Historique->Items->Insert(0);

                ListItem->Caption = read.DateTime;
                ListItem->SubItems->Add(read.Exp);
                ListItem->SubItems->Add(read.Dest);
                ListItem->SubItems->Add(read.NumMsg);

                if ( read.ChkMsg == true )
                        ListItem->SubItems->Add( "X" );
                else
                        ListItem->SubItems->Add( "" );

                ListItem->SubItems->Add( read.msg );
                ListItem = Historique->Items->Insert(0);

                delete ListItem;
        }

        FileClose( fichier );

        // Toujour o premier plan
        if ( Options->ReadBool( "General", "AllForeground", false ) == true )
                this->FormStyle = fsStayOnTop;

        delete Options;
}
//---------------------------------------------------------------------------

void __fastcall THistoriqueForm::CancelClick(TObject *Sender)
{
        EffAll=false;
        Close();
}
//---------------------------------------------------------------------------

void __fastcall THistoriqueForm::EraseClick(TObject *Sender)
{
        EffAll=true;
        Historique->Clear();
}
//---------------------------------------------------------------------------

void __fastcall THistoriqueForm::EraseSelectClick(TObject *Sender)
{
        if ( Historique->Selected == NULL )
                return;
        Historique->Selected->Delete();
}
//---------------------------------------------------------------------------

void __fastcall THistoriqueForm::AppliquerClick(TObject *Sender)
{
        TListItem *ListItemTest;

        DeleteFile( "Historique.log" );

        int fichier = 0, j = ( Historique->Items->Count - 1 );

        if ( !FileExists( "Historique.log" ) )
                fichier = FileCreate( "Historique.log" );
        else
                fichier = FileOpen( "Historique.log", fmOpenWrite );

        while(1)
        {
                struct fiche write;

                TListItem *ListItemSave;

                ListItemSave = Historique->Items->Item[j];

                if ( ListItemSave == NULL )
                {
                        ListItemSave = NULL;
                        delete ListItemSave;
                        break;
                }

                StrPCopy( write.DateTime, ListItemSave->Caption );
                StrPCopy( write.Exp, ListItemSave->SubItems->Strings[0] );
                StrPCopy( write.Dest, ListItemSave->SubItems->Strings[1] );
                write.NumMsg = StrToInt( ListItemSave->SubItems->Strings[2] );
                if ( ListItemSave->SubItems->Strings[3] == "X" )
                        write.ChkMsg = true;
                else
                        write.ChkMsg = false;
                StrPCopy( write.msg, ListItemSave->SubItems->Strings[4] );

                FileWrite( fichier, &write, sizeof( struct fiche ));
                j--;
        }
        FileClose( fichier );

        ListItemTest = NULL;
        delete ListItemTest;

        if ( Historique->Selected != NULL )
        {
                TListItem *ListItemSelect;

                ListItemSelect = Historique->Selected;

                H2ONetSender->NomExpEdit->Text = ListItemSelect->SubItems->Strings[0];
                H2ONetSender->NomDestRadio->Checked = true;
                H2ONetSender->NomDestEdit->Text = ListItemSelect->SubItems->Strings[1];
                H2ONetSender->NombreMessageEdit->Text = StrToInt( ListItemSelect->SubItems->Strings[2] );

                switch( StrToInt( ListItemSelect->SubItems->Strings[2] ) )
                {
                case 1 : H2ONetSender->TrackBar->Position = 0;break;
                case 2 : H2ONetSender->TrackBar->Position = 1;break;
                case 3 : H2ONetSender->TrackBar->Position = 2;break;
                case 5 : H2ONetSender->TrackBar->Position = 3;break;
                case 10 : H2ONetSender->TrackBar->Position = 4;break;
                case 20 : H2ONetSender->TrackBar->Position = 5;break;
                case 30 : H2ONetSender->TrackBar->Position = 6;break;
                case 51 : H2ONetSender->TrackBar->Position = 7;break;
                case 69 : H2ONetSender->TrackBar->Position = 8;break;
                case 100 : H2ONetSender->TrackBar->Position = 9;break;
                case 150 : H2ONetSender->TrackBar->Position = 10;break;
                case 200 : H2ONetSender->TrackBar->Position = 11;break;
                case 300 : H2ONetSender->TrackBar->Position = 12;break;
                case 500 : H2ONetSender->TrackBar->Position = 13;break;
                case 666 : H2ONetSender->TrackBar->Position = 14;break;
                case 1000 : H2ONetSender->TrackBar->Position = 15;break;
                case 1500 : H2ONetSender->TrackBar->Position = 16;break;
                case 2000 : H2ONetSender->TrackBar->Position = 17;break;
                case 5000 : H2ONetSender->TrackBar->Position = 18;break;
                case 10000 : H2ONetSender->TrackBar->Position = 19;break;
                case 99999 : H2ONetSender->TrackBar->Position = 20;break;
                }

                if ( ListItemSelect->SubItems->Strings[3] == 'X' )
                        H2ONetSender->NumeroMessageCheck->Checked = true;
                else
                        H2ONetSender->NumeroMessageCheck->Checked = false;

                H2ONetSender->MessageEdit->Text = ListItemSelect->SubItems->Strings[4];

                ListItemSelect = NULL;
                delete ListItemSelect;
        }

        Close();
}
//---------------------------------------------------------------------------


void __fastcall THistoriqueForm::HistoriqueDblClick(TObject *Sender)
{
        THistoriqueForm::AppliquerClick(Sender);
}
//---------------------------------------------------------------------------


void __fastcall THistoriqueForm::HistoriqueKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
        if ( Key == VK_DELETE )
                THistoriqueForm::EraseSelectClick(Sender);
        if ( Key == VK_RETURN )
                THistoriqueForm::AppliquerClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall THistoriqueForm::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        Historique->ItemIndex = -1;
}
//---------------------------------------------------------------------------

void __fastcall THistoriqueForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
      if(EffAll==true)DeleteFile( "Historique.log" );
}
//---------------------------------------------------------------------------

void __fastcall THistoriqueForm::HistoriqueColumnClick(TObject *Sender,
      TListColumn *Column)
{
      ColumnToSort = Column->Index;
      ((TCustomListView *)Sender)->AlphaSort();
}
//---------------------------------------------------------------------------

void __fastcall THistoriqueForm::HistoriqueCompare(TObject *Sender,
      TListItem *Item1, TListItem *Item2, int Data, int &Compare)
{
   if (ColumnToSort == 0)
     Compare = CompareText(Item1->Caption,Item2->Caption);
   else
   {
     int ix;
     ix = ColumnToSort - 1;
     Compare = CompareText(Item1->SubItems->Strings[ix], Item2->SubItems->Strings[ix]);
   }
}
//---------------------------------------------------------------------------

