//---------------------------------------------------------------------------

#include <winsock2.h>                   // Pour la detection parametre reseau
#include <lm.h>
#include <windows.h>
#include <inifiles.hpp>                 // Pour la gestion des fichier ".ini"
#include <Registry.hpp>                 // Pour la gestion des cles du registre

#include <vcl.h>                        // Composant VCL
#pragma hdrstop

#include "Confirmform.h"                // Pour la fiche de confirmation de mise en pause
#include "RacourcisForm.h"              // La fentre de racourcis
#include "Historique.h"                 // La fentre de l'historique
#include "ThreadEnumNetRes.h"           // Thread pour numration des pc en rzo
#include "ThreadCloseNetSend.h"         // Thread pour clore les net sended
#include "ThreadSendMsg.h"              // Thread pour envoi des mesages
#include "ThreadPrevisualiser.h"        // Thread pour la previsualisation du message
#include "ThreadDemarrage.h"            // Thread pour chaque dmarrage du programme
#include "H2OFonctions.h"               // Fonctions pour API windows (Net Send)
#include "NetSenderForm.h"              // Form principale en-tte

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TH2ONetSender *H2ONetSender;
//---------------------------------------------------------------------------

struct fiche                              // Structure pour la sauvegarde historique
{
        char DateTime[50];
        int NumMsg;                       // Rcupration valeur nombre message
        bool ChkMsg;                      // Bouton "Indiquer numro msg"
                                          //    Structure pour la gestion des fiches
        char Exp[32];                     // Rcupration de l'expediteur
        char Dest[32];                    // Rcupration du (des) destinataire(s)
        char msg[878];                    // Rcupration du mssage
};

int TestIpEx = -1;                        // Variable globale je c, c po bien mais bon
// TestIpEx = -1 => Valeur par dfaut
// TestIpEx = 0 => Apres ping, l'ip n'exist pas
// TestIpEx = 1 => L'ip doit tre ajoute  la liste si exist o ping
// TestIpEx = 2 => L'ip ne doit pas tre ajoute

ThreadEnumNetRes *ThreadEnum;             //
CloseNetSend *ThreadClose;                //
ThreadSendMsg *ThreadSend;                // Crer les threads en global, c encore moin bien mais bon ...
ThreadPrevisualiser *ThreadPre;           // enfin je crois ;-)
ThreadDemarrage *ThreadDem;               ///////////////////////////////////////////////////////////////

__fastcall TH2ONetSender::TH2ONetSender(TComponent* Owner)
        : TForm(Owner)
{
        DecimalSeparator = '.';

        TIniFile *Options = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

        // Toujour o premier plan
        if ( Options->ReadBool( "General", "AllForeground", false ) == true )
                H2ONetSender->FormStyle = fsStayOnTop;

        delete Options;

//////////////////////////////////////////////////////////////
//                                                          //
//    Code pour recuprer Nom rseau et Ip de l'utilisateur //
//                                                          //
//////////////////////////////////////////////////////////////
      WORD wVersionRequested;
      WSADATA wsaData;
      char name[255];
      AnsiString ip;
      PHOSTENT hostinfo;
      wVersionRequested = MAKEWORD( 2, 0 );

      if ( WSAStartup( wVersionRequested, &wsaData ) == 0 )
      {
           if( gethostname( name, sizeof( name ) ) == 0 )
           {
                MonNom->Caption = name;         // Affichage nom de l'ordinateur
                if( ( hostinfo = gethostbyname( name ) ) != NULL )
                {
                   ip = inet_ntoa (*(in_addr *)*hostinfo->h_addr_list);
                   MonIp->Caption = ip;         // Affichage adresse IP
                }
           }
           WSACleanup( );
      }
// Fin du code pour Ip et nom rseau :D

// Progressbar ds statusbar
      StatusBar->ControlStyle = StatusBar->ControlStyle << csAcceptsControls;
      ProgressBar->Left = 198;
      ProgressBar->Top = 2;
      ProgressBar->Parent = StatusBar;

// positionnement bouton options
      Image3->Left = ClientWidth - Image3->Width + 1;
      Image4->Left = ClientWidth - Image4->Width + 1;

// Ici on charge la "mmoire" des combo box avec les donnees deja entrees
      TIniFile *Ini = new TIniFile( ExtractFilePath( Application->ExeName ) + "Options.ini");

      for ( int a = 0; a < 30; a++ )
      {
                if ( Ini->ReadString( "Save", "Exp" + IntToStr( a ), "" ) != "" )
                        NomExpEdit->Items->Add( Ini->ReadString( "Save", "Exp" + IntToStr( a ), "" ) );
                if ( Ini->ReadString( "Save", "Dest" + IntToStr( a ), "" ) != "" )
                        NomDestEdit->Items->Add( Ini->ReadString( "Save", "Dest" + IntToStr( a ), "" ) );
      }

      // Save position or center prog
      if ( Ini->ReadBool("General", "Center", true ) != true )
      {
               H2ONetSender->Position = poDesigned;
               H2ONetSender->Left = Ini->ReadInteger( "General", "PosX", 100 );
               H2ONetSender->Top = Ini->ReadInteger( "General", "PosY", 100 );
      }

      // Actu toutes les ...
      if ( Ini->ReadBool("ListeDest", "Refresh", true ) == true )
                ActuTimer->Interval = Ini->ReadInteger( "ListeDest", "TimeRefresh", 180000 );
      else
      {
                ActuTimer->Interval = Ini->ReadInteger( "ListeDest", "TimeRefresh", 180000 );
                ActuTimer->Enabled = false;
      }

      Ini->WriteBool( "General", "Open", false );
      Ini->WriteBool( "APropos", "Open", false );

      ThreadEnum = new ThreadEnumNetRes( false, true );   // Thread enum net res
      ThreadEnum->OnTerminate = FinThreadEnum;            // Fin du thread

      ThreadDem = new ThreadDemarrage( false );           // Thread Dmarrage
      ThreadDem->OnTerminate = FinThreadDemarrage;        // Fin du Thread de dmarrage

      delete Ini;
}
//---------------------------------------------------------------------------


                  // Bouton du main menu
                  //////////////////////


/****** Menu Fichier ******/
void __fastcall TH2ONetSender::Envoyer1Click(TObject *Sender)
{
        TH2ONetSender::EnvoyerClick( Sender );
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Historique1Click(TObject *Sender)
{
        TH2ONetSender::HistoriqueClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Previsualiser1Click(TObject *Sender)
{
        TH2ONetSender::PrevisualiserClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Quitter1Click(TObject *Sender)
{
        Close();            // Fermeture Form principale
}
//---------------------------------------------------------------------------


/****** Menu Edition ******/

// Flood
void __fastcall TH2ONetSender::Augmenterlenombredemsg1Click(
      TObject *Sender)
{
        TrackBar->Position++;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Dimuerlenombredemsg1Click(TObject *Sender)
{
       TrackBar->Position--;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Indiquerlenumrodumsg1Click(TObject *Sender)
{
        NumeroMessageCheck->Checked = !NumeroMessageCheck->Checked;
                  // Inversion de l'etat du controle
}
//---------------------------------------------------------------------------

// Effacer tout
void __fastcall TH2ONetSender::Effacer1Click(TObject *Sender)
{
       NomExpEdit->Text = "";

       NomDestRadio->Checked = false;
       NomDestEdit->Text = "";

       ListeDestRadio->Checked = false;
       for ( int l = 0; l < DestListe->Count; l++ )
                DestListe->State[l] = cbUnchecked;
                                    // Dselectionnent tous les destinataires de la liste

       TrackBar->Position = 0;
       NombreMessageEdit->Text = "1";
       NumeroMessageCheck->Checked = false;

       MessageEdit->Clear();
}
//---------------------------------------------------------------------------


/******* Menu Options ***********/

// Anti net send
void __fastcall TH2ONetSender::Activer1Click(TObject *Sender)
{
        TH2ONetSender::AntiNetSendClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Desactiver1Click(TObject *Sender)
{
        TH2ONetSender::AntiNetSendClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::FloodErasor1Click(TObject *Sender)
{
        TH2ONetSender::CloseNetSendedClick(Sender);
}
//---------------------------------------------------------------------------

// Liste destinataire
void __fastcall TH2ONetSender::Ajouterlaliste1Click(TObject *Sender)
{
        TH2ONetSender::AjoutNomListeClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Retirerdelaliste1Click(TObject *Sender)
{
        TH2ONetSender::SupprElementListeClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Actualise1Click(TObject *Sender)
{
        TH2ONetSender::ActualiserClick(Sender);
}
//---------------------------------------------------------------------------

// Options
//////////
void __fastcall TH2ONetSender::Options1Click(TObject *Sender)
{
// Preparation de l'etat des controles
        TIniFile *Options = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

        if ( Options->ReadBool( "General", "Open", false ) == true )
                return;

        Options->WriteBool( "General", "Open", true );

// Group General
////////////////

        // Run Windows
        if ( Options->ReadBool( "General", "RunWin", false ) == true )
                RunWinCheck->Checked = true;
        else
                RunWinCheck->Checked = false;

        // Minimizer demarrage
        if ( Options->ReadBool( "General", "MiniRun", false ) == true )
                MiniRunCheck->Checked = true;
        else
                MiniRunCheck->Checked = false;

        // Minimizer a chaque envoi
        if ( Options->ReadBool( "General", "MiniSend", false ) == true )
                MiniSendCheck->Checked = true;
        else
                MiniSendCheck->Checked = false;

        // Effcer apres chaque envoi
        if ( Options->ReadBool( "General", "EraseSend", false ) == true )
                EraseSendCheck->Checked = true;
        else
                EraseSendCheck->Checked = false;

        // Toujour o premier plan
        if ( Options->ReadBool( "General", "AllForeground", false ) == true )
                AllForegroundCheck->Checked = true;
        else
                AllForegroundCheck->Checked = false;

// Group Historique
////////////////////
        // Sauvegarde message ?
        if ( Options->ReadBool("Historique", "Save", true ) == true )
                AlwaysSaveMsgCheck->Checked = true;
        else
                AlwaysSaveMsgCheck->Checked = false;

        // Limiter taille historique ?
        if ( Options->ReadBool("Historique", "Limit", true ) == true )
        {
                LimitLogCheck->Checked = true;
                MaxListLogCombo->Text = Options->ReadInteger("Historique", "Max", 1000 );
        }
        else
        {
                MaxListLogCombo->Enabled = false;
                MaxListLogCombo->Text = Options->ReadInteger("Historique", "Max", 1000 );
                LimitLogCheck->Checked = false;
        }


// Group Liste destinataire
////////////////////////////

        // Actu toutes les ...
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==1)
            RefreshTimeCombo->ItemIndex = 0;
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==2)
            RefreshTimeCombo->ItemIndex = 1;
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==3)
            RefreshTimeCombo->ItemIndex = 2;
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==5)
            RefreshTimeCombo->ItemIndex = 3;
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==10)
            RefreshTimeCombo->ItemIndex = 4;
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==15)
            RefreshTimeCombo->ItemIndex = 5;
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==30)
            RefreshTimeCombo->ItemIndex = 6;
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==60)
            RefreshTimeCombo->ItemIndex = 7;
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==90)
            RefreshTimeCombo->ItemIndex = 8;
        if((Options->ReadInteger("ListeDest", "TimeRefresh", 180000 ) / 60000)==120)
            RefreshTimeCombo->ItemIndex = 9;

        if ( Options->ReadBool("ListeDest", "Refresh", true ) == true )
             RefreshRadio->Checked == true;
        else
             NeverRefreshRadio->Checked = true;

// Group Position
/////////////////
        // Save position or center prog
        if ( Options->ReadBool("General", "Center", true ) == true )
                CenterRadio->Checked = true;
        else
                SavePositionRadio->Checked = true;

// Group Anti-Net Send
//////////////////////
        // Activer  chaque dmarrage
        if ( Options->ReadBool("ANS", "StartWin", false ) == true )
                ActivANSCheck->Checked = true;
        else
                ActivANSCheck->Checked = false;

        // Toujour mettre en pause
        if ( Options->ReadBool("ANS", "Pause", false ) == true )
                PauseANSCheck->Checked = true;
        else
                PauseANSCheck->Checked = false;

        delete Options;

        Image4->Visible = false;
        Image5->Visible = false;
        Image2->Visible = true;

// Positionnement
        OptionPanel->Left = 451;
        OptionPanel->Width = 450;
        OptionPanel->Visible = true;

// Affichage de gauche a droite
        for ( float i = 451; i >= 0; i = i - 8.98 )
        {
                OptionPanel->Left = i;
                Application->ProcessMessages();
                Sleep( (unsigned long) 5 );
        }
        ExpGroupBox->Visible = false;
        DestGroupBox->Visible = false;
        FloodGroupBox->Visible = false;
        InfoGroupBox->Visible = false;
        MessageGroupBox->Visible = false;
        StatusBar->Visible = false;

        Image3->Visible = false;
        Image2->Visible = true;

        Application->ProcessMessages();
}
//---------------------------------------------------------------------------


/****** Menu ? ******/


void __fastcall TH2ONetSender::AideNetSender1Click(TObject *Sender)
{
        ShellExecute( Handle, "open", "Aide H.2.O Net Sender.chm", 0, 0, SW_SHOWMAXIMIZED );
                      // Affichge fichier aide li
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Racourcis1Click(TObject *Sender)
{
        RaccourcisForm->ShowModal();     // Affichage fentre "Racourcis"
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Apropos1Click(TObject *Sender)
{
        TIniFile *Ini = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

        if ( Ini->ReadBool( "APropos", "Open", false ) == true )
                return;

        Ini->WriteBool( "APropos", "Open", true );

        delete Ini;

        ExpGroupBox->Enabled = false;
        DestGroupBox->Enabled = false;
        FloodGroupBox->Enabled = false;
        InfoGroupBox->Enabled = false;
        MessageGroupBox->Enabled = false;
        OptionPanel->Enabled = false;

// Positionnement
        AProposPanel->Top = -311;
        AProposPanel->Height = 315;
        AProposPanel->Visible = true;

// Affichage de haut en bas
        for ( float i = -315; i <= 0; i = i + 6.3 )
        {
                AProposPanel->Top = i;
                Application->ProcessMessages();
                Sleep( (unsigned long) 5 );
        }
}
//---------------------------------------------------------------------------


                  // Bouton menu Systray
                  //////////////////////

void __fastcall TH2ONetSender::Afficherlaide1Click(TObject *Sender)
{
        TH2ONetSender::AideNetSender1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Racourcis2Click(TObject *Sender)
{
        TH2ONetSender::Racourcis1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::AproposdH2ONetSender1Click(TObject *Sender)
{
        TH2ONetSender::Apropos1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Options2Click(TObject *Sender)
{
        TH2ONetSender::Options1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Historique2Click(TObject *Sender)
{
        TH2ONetSender::HistoriqueClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Activer2Click(TObject *Sender)
{
        TH2ONetSender::AntiNetSendClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::FloodErasor2Click(TObject *Sender)
{
        TH2ONetSender::CloseNetSendedClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Envoyer2Click(TObject *Sender)
{
        TH2ONetSender::EnvoyerClick( Sender );
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Quitter2Click(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------


                // Groupe Expditeur
                ////////////////////

void __fastcall TH2ONetSender::NomExpEditKeyPress(TObject *Sender,
      char &Key)
{
        if ( ( Key == ',' ) || ( Key == ';' ) || ( Key == '/' ) || ( Key == '"' ) || ( Key == '[' ) || ( Key == ']' ) || ( Key == '<' ) || ( Key == '\\' ) ||
             ( Key == '!' ) || ( Key == '?' ) || ( Key == ':' ) || ( Key == '=' ) || ( Key == '|' ) || ( Key == '+' ) || ( Key == '>' ) )
        {
                Key = 0;
                StatusBar->Panels->Items[0]->Text = "Caractre interdit ici";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
        }
}
//---------------------------------------------------------------------------


                // Groupe Destinataire
                //////////////////////

void __fastcall TH2ONetSender::NomDestEditChange(TObject *Sender)
{
        NomDestRadio->Checked = true;
}
//---------------------------------------------------------------------------


/*************** Boutons image Ajout Liste ************/
void __fastcall TH2ONetSender::AjoutNomListeClick(TObject *Sender)
{
// TestIpEx = -1 => Valeur par dfaut
// TestIpEx = 0 => Apres ping, l'ip n'exist pas
// TestIpEx = 1 => L'ip doit tre ajoute  la liste si exist o ping
// TestIpEx = 2 => L'ip ne doit pas tre ajoute

        if ( ( NomDestEdit->Text == "" ) ||        // Nom Destinataire non saisi
             ( NomDestEdit->Text == " " ) )        // Ou espace saisie
        {
                StatusBar->Panels->Items[0]->Text = "Aucun nom de destinataire saisi";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }
        else
        {
                StatusBar->Panels->Items[0]->Text = "Vrification du destinataire en cours ...";
                Application->ProcessMessages();

                char host[32];
                PHOSTENT name ;

                TestIpEx = 1;
                ICMP->ReceiveTimeout = 3000;

                StrPCopy( host, NomDestEdit->Text );

                try
                {
                        ICMP->Host = NomDestEdit->Text;
                        ICMP->Ping();
                        if ( TestIpEx == 0 )
                        {
                                name = gethostbyname( host );

                                if ( name == NULL )
                                {
                                        StatusBar->Panels->Items[0]->Text = "L'adresse ip n'xiste pas";
                                        MessageBeep( MB_ICONEXCLAMATION );
                                        Timer->Enabled = false;
                                        Timer->Enabled = true;
                                        return;
                                }
                                else
                                {
                                        // Sauvegarde destinataire
                                        ////////////////////////////////////////
                                                int TestDest = 0;

                                                for ( int j = 0; j < 30; j++ )
                                                {
                                                        if ( NomDestRadio->Checked == true )
                                                        {
                                                                if ( NomDestEdit->Text == NomDestEdit->Items->Strings[j] )
                                                                        TestDest = 1;
                                                        }
                                                        if ( NomDestRadio->Checked == false )
                                                                  TestDest = -1;
                                                }
                                                if ( TestDest == 0 )
                                                        NomDestEdit->Items->Insert( 0, NomDestEdit->Text );

                                                TIniFile *Ini = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

                                                for ( int a = 0; a < 30; a++ )
                                                        Ini->WriteString( "Save", "Dest" + IntToStr( a ), NomDestEdit->Items->Strings[a] );

                                                delete Ini;
                                        //////////////////////////////////////////////////////////////////////////////////////////////////////////


                                        // Code vrif dest exist deja ds la liste ???
                                        ////////////////////////////////////////////

                                        bool testExist = false;
                                        for ( int l = 0; l < DestListe->Count; l++ )
                                        {
                                                if ( NomDestEdit->Text == DestListe->Items->Strings[l] )
                                                {
                                                        testExist = true;
                                                        break;
                                                }
                                        }
                                        ////////////////////////////////////////////

                                        if ( testExist == false )
                                        {
                                                DestListe->Items->Insert( 0, NomDestEdit->Text ); // Ajout sur la pile
                                                ListeDestRadio->Checked = true;
                                                StatusBar->Panels->Items[0]->Text = "Prt";
                                                return;
                                        }
                                        else
                                        {
                                                StatusBar->Panels->Items[0]->Text = "Le destinataire est dj dans la liste";
                                                MessageBeep( MB_ICONEXCLAMATION );
                                                Timer->Enabled = false;
                                                Timer->Enabled = true;
                                                return;
                                        }

                                }
                        }
                }
                catch(...)
                {
                        name = gethostbyname( host );

                        if ( name == NULL )
                        {
                                StatusBar->Panels->Items[0]->Text = "L'adresse ip n'xiste pas";
                                MessageBeep( MB_ICONEXCLAMATION );
                                Timer->Enabled = false;
                                Timer->Enabled = true;
                                return;
                        }
                        else
                        {
                                // Sauvegarde destinataire
                                ////////////////////////////////////////
                                        int TestDest = 0;

                                        for ( int j = 0; j < 30; j++ )
                                        {
                                                if ( NomDestRadio->Checked == true )
                                                {
                                                        if ( NomDestEdit->Text == NomDestEdit->Items->Strings[j] )
                                                                TestDest = 1;
                                                }
                                                if ( NomDestRadio->Checked == false )
                                                          TestDest = -1;
                                        }
                                        if ( TestDest == 0 )
                                                NomDestEdit->Items->Insert( 0, NomDestEdit->Text );

                                        TIniFile *Ini = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

                                        for ( int a = 0; a < 30; a++ )
                                                Ini->WriteString( "Save", "Dest" + IntToStr( a ), NomDestEdit->Items->Strings[a] );

                                        delete Ini;
                                //////////////////////////////////////////////////////////////////////////////////////////////////////////


                                // Code vrif dest exist deja ds la liste ???
                                /////////////////////////////////////////////

                                bool testExist = false;
                                for ( int l = 0; l < DestListe->Count; l++ )
                                {
                                        if ( NomDestEdit->Text == DestListe->Items->Strings[l] )
                                        {
                                                testExist = true;
                                                break;
                                        }
                                }
                                ////////////////////////////////////////////

                                if ( testExist == false )
                                {
                                        DestListe->Items->Insert( 0, NomDestEdit->Text ); // Ajout sur la pile
                                        ListeDestRadio->Checked = true;
                                        StatusBar->Panels->Items[0]->Text = "Prt";
                                        return;
                                }
                                else
                                {
                                        StatusBar->Panels->Items[0]->Text = "Le destinataire est dj dans la liste";
                                        MessageBeep( MB_ICONEXCLAMATION );
                                        Timer->Enabled = false;
                                        Timer->Enabled = true;
                                        return;
                                }
                        }
                }
        }
}
//---------------------------------------------------------------------------


void __fastcall TH2ONetSender::DestListeClick(TObject *Sender)
{
        ListeDestRadio->Checked = true;

        char host[32];
        AnsiString ip;
        PHOSTENT name;

        if ( DestListe->ItemIndex <= -1 )
                 return;

        StrPCopy( host, DestListe->Items->Strings[DestListe->ItemIndex] );

        name = gethostbyname( host );

        if ( name == NULL )
        {
                StatusBar->Panels->Items[0]->Text = "Adresse ip inconnue" ;
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }
        else
        {
                ip = inet_ntoa (*(in_addr *)*name->h_addr_list);
                AnsiString Final = "Adresse ip : " + ip;
                StatusBar->Panels->Items[0]->Text = Final;
                Timer->Enabled = false;
                Timer->Enabled = true;
        }
}
//---------------------------------------------------------------------------


/*************** Boutons pour actualiser les pc connecter ********************/
void __fastcall TH2ONetSender::ActualiserClick(TObject *Sender)
{
        if ( ThreadEnum != NULL )
                return;

        DestListe->Items->Clear();

        ThreadEnum = new ThreadEnumNetRes( false, false );   // Thread enum net res
        ThreadEnum->OnTerminate = FinThreadEnum;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::DestListeDblClick(TObject *Sender)
{
        if ( DestListe->ItemIndex <= -1 )
                 return;

        DestListe->State[DestListe->ItemIndex] = !DestListe->State[DestListe->ItemIndex];
                // Inversion de l'etat du destinataire focused
}
//---------------------------------------------------------------------------

/*************** Boutons image suppr Liste ************/
void __fastcall TH2ONetSender::SupprElementListeClick(TObject *Sender)
{
        if ( DestListe->ItemIndex <= (-1) )
        {
                StatusBar->Panels->Items[0]->Text = "Aucun lment saisi dans la liste";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }
        else
        {
                DestListe->Items->Delete( DestListe->ItemIndex );     // Suppression de l'lment, actualisation du count
                ListeDestRadio->Checked = true;
        }
}
//---------------------------------------------------------------------------


                // Groupe Flood
                ///////////////

void __fastcall TH2ONetSender::NombreMessageEditKeyPress(TObject *Sender, char &Key)
{
        if ( ( Key < 48 || Key > 57 ) && ( Key != VK_BACK ) && ( Key != VK_DELETE ) )
                Key = 0;                 // Impossible d'entree autre chose kun entier
                                         /////////////////////////////////////////////
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::TrackBarChange(TObject *Sender)
{
        int Position = TrackBar->Position;
        switch( Position )
        {
        case 0 : NombreMessageEdit->Text = 1;TrackBar->SelEnd = 0;break;
        case 1 : NombreMessageEdit->Text = 2;TrackBar->SelEnd = 1;break;
        case 2 : NombreMessageEdit->Text = 3;TrackBar->SelEnd = 2;break;
        case 3 : NombreMessageEdit->Text = 5;TrackBar->SelEnd = 3;break;
        case 4 : NombreMessageEdit->Text = 10;TrackBar->SelEnd = 4;break;
        case 5 : NombreMessageEdit->Text = 20;TrackBar->SelEnd = 5;break;
        case 6 : NombreMessageEdit->Text = 30;TrackBar->SelEnd = 6;break;
        case 7 : NombreMessageEdit->Text = 51;TrackBar->SelEnd = 7;break;
        case 8 : NombreMessageEdit->Text = 69;TrackBar->SelEnd = 8;break;
        case 9 : NombreMessageEdit->Text = 100;TrackBar->SelEnd = 9;break;
        case 10 : NombreMessageEdit->Text = 150;TrackBar->SelEnd = 10;break;
        case 11 : NombreMessageEdit->Text = 200;TrackBar->SelEnd = 11;break;
        case 12 : NombreMessageEdit->Text = 300;TrackBar->SelEnd = 12;break;
        case 13 : NombreMessageEdit->Text = 500;TrackBar->SelEnd = 13;break;
        case 14 : NombreMessageEdit->Text = 666;TrackBar->SelEnd = 14;break;
        case 15 : NombreMessageEdit->Text = 1000;TrackBar->SelEnd = 15;break;
        case 16 : NombreMessageEdit->Text = 1500;TrackBar->SelEnd = 16;break;
        case 17 : NombreMessageEdit->Text = 2000;TrackBar->SelEnd = 17;break;
        case 18 : NombreMessageEdit->Text = 5000;TrackBar->SelEnd = 18;break;
        case 19 : NombreMessageEdit->Text = 10000;TrackBar->SelEnd = 19;break;
        case 20 : NombreMessageEdit->Text = 99999;TrackBar->SelEnd = 20;break;
        }
}
//---------------------------------------------------------------------------


                // Groupe Message
                /////////////////

void __fastcall TH2ONetSender::HistoriqueClick(TObject *Sender)
{
        CreateMutex( NULL, FALSE, "Hist" );
        if ( GetLastError() == ERROR_ALREADY_EXISTS )
        {               // Pour pas afficher 2 fois la meme form
                delete HistoriqueForm2;
                HistoriqueForm2 = new THistoriqueForm( NULL );
                HistoriqueForm2->Show();
                return;
        }

        HistoriqueForm2 = new THistoriqueForm( NULL ); 		// Cre la fiche dynamiquement
        HistoriqueForm2->Show();       		                // Affiche la fiche
}
//---------------------------------------------------------------------------


void __fastcall TH2ONetSender::PrevisualiserClick(TObject *Sender)
{
//////////////////
// Vrification //
//////////////////

        /********************
        * Groupe expditeur *
        ********************/

        char verif[30];
        StrPCopy( verif, NomExpEdit->Text );

        if ( NomExpEdit->Text == "" )
        {
                StatusBar->Panels->Items[0]->Text = "Aucun expditeur saisi";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }
        if ( ( verif[0] == ' ' ) || ( verif[0] == '.' ) )
        {
                StatusBar->Panels->Items[0]->Text = "Expditeur incorrect (Premier caractre)";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }
        /*****************
        * Groupe message *
        *****************/

        if ( MessageEdit->Text == "" )
        {
                StatusBar->Panels->Items[0]->Text = "Aucun message n'a t saisi";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }

        if ( ( H2ONetSender->NomExpEdit->Text == "NICOLAS" ) && ( H2ONetSender->NomDestEdit->Text == "DOBLER" ) && ( H2ONetSender->MessageEdit->Text == "antoine" ) || ( H2ONetSender->MessageEdit->Text == "ANTOINE" ) )
        {
                Fiche0 = new TEasterEgg(NULL);
                Fiche1 = new TEasterEgg(NULL);
                Fiche2 = new TEasterEgg(NULL);
                Fiche3 = new TEasterEgg(NULL);
                Fiche4 = new TEasterEgg(NULL);
                Fiche5 = new TEasterEgg(NULL);
                Fiche6 = new TEasterEgg(NULL);
                Fiche7 = new TEasterEgg(NULL);
                Fiche8 = new TEasterEgg(NULL);

                Fiche0->Left = 500; Fiche0->Top = 50;
                Fiche1->Left = 15; Fiche1->Top = 30;
                Fiche2->Left = 300; Fiche2->Top = 280;
                Fiche3->Left = 330; Fiche3->Top = 15;
                Fiche4->Left = 30; Fiche4->Top = 300;
                Fiche5->Left = 400; Fiche5->Top = 430;
                Fiche6->Left = 150; Fiche6->Top = 400;
                Fiche7->Left = 650; Fiche7->Top = 100;
                Fiche8->Left = 630; Fiche8->Top = 400;

                Fiche0->Show();
                Sleep( (unsigned long) 70 );
                Fiche1->Show();
                Sleep( (unsigned long) 40 );
                Fiche2->Show();
                Sleep( (unsigned long) 10 );
                Fiche3->Show();
                Sleep( (unsigned long) 100 );
                Fiche4->Show();
                Sleep( (unsigned long) 85 );
                Fiche5->Show();
                Sleep( (unsigned long) 20 );
                Fiche6->Show();
                Sleep( (unsigned long) 50 );
                Fiche7->Show();
                Sleep( (unsigned long) 75 );
                Fiche8->Show();
                return;
        }

        Conf = new TConfirm( NULL ); 		// Cre la fiche dynamiquement

        ThreadPre = new ThreadPrevisualiser( false );   // Thread envoi message
        ThreadPre->OnTerminate = FinThreadPrevisualiser;      // Fin du thread
}
//---------------------------------------------------------------------------


/********** Bouton Envoyer ***********/
/*************************************/
void __fastcall TH2ONetSender::EnvoyerClick(TObject *Sender)
{
//////////////////
// Vrification //
//////////////////

        /********************
        * Groupe expditeur *
        ********************/

        char verif[30];
        StrPCopy( verif, NomExpEdit->Text );

        if ( NomExpEdit->Text == "" )
        {
                StatusBar->Panels->Items[0]->Text = "Aucun nom d'expditeur saisi";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }
        if ( ( verif[0] == ' ' ) || ( verif[0] == '.' ) )
        {
                StatusBar->Panels->Items[0]->Text = "Expditeur incorrect (Premier caractre)";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }

        /**********************
        * Groupe destinataire *
        **********************/

        StrPCopy( verif, NomExpEdit->Text );

        if ( ( NomDestRadio->Checked == false ) &&  // Aucun radio selectionn
             ( ListeDestRadio->Checked == false ) )
        {
                StatusBar->Panels->Items[0]->Text = "Aucun destinataire slectionn";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }
        if ( NomDestRadio->Checked == true )        // Nom destinataire slectionn
        {
                if ( (NomDestEdit->Text == " ") || ( NomDestEdit->Text == "" ) ) // Verifie si un nom a ete entree
                {
                        StatusBar->Panels->Items[0]->Text = "Aucun nom de destinataire saisi";
                        MessageBeep( MB_ICONEXCLAMATION );
                        Timer->Enabled = false;
                        Timer->Enabled = true;
                        return;
                }
        }
        if ( ListeDestRadio->Checked == true )
        {
                if ( DestListe->ItemIndex < 0 )
                {
                        StatusBar->Panels->Items[0]->Text = "Aucun destinataire choisi dans la liste";
                        MessageBeep( MB_ICONEXCLAMATION );
                        Timer->Enabled = false;
                        Timer->Enabled = true;
                        return;
                }
                if ( DestListe->ItemIndex >= 0 )
                {
                        bool test = false;

                        for ( int k = 0; k < DestListe->Count; k++ )
                        {
                                if ( DestListe->State[k] == true )
                                {
                                        test = true;
                                        break;
                                }
                        }
                        if ( test == false )
                        {
                                StatusBar->Panels->Items[0]->Text = "Aucun destinataire choisi dans la liste";
                                MessageBeep( MB_ICONEXCLAMATION );
                                Timer->Enabled = false;
                                Timer->Enabled = true;
                                return;
                        }
                }
        }

        /***************
        * Groupe Flood *
        ***************/

        if ( NombreMessageEdit->Text == 0 )
        {
                StatusBar->Panels->Items[0]->Text = "0 est un nombre de message invalide";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }
        if ( NombreMessageEdit->Text == "" )
        {
                StatusBar->Panels->Items[0]->Text = "Aucun nombre de message saisi";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }

        /*****************
        * Groupe message *
        *****************/

        if ( MessageEdit->Text == "" )
        {
                StatusBar->Panels->Items[0]->Text = "Aucun texte de message saisi";
                MessageBeep( MB_ICONEXCLAMATION );
                Timer->Enabled = false;
                Timer->Enabled = true;
                return;
        }

// Verification du destinataire
// TestIpEx = -1 => Valeur par dfaut
// TestIpEx = 0 => Apres ping, l'ip n'exist pas
// TestIpEx = 1 => L'ip doit tre ajoute  la liste si exist o ping
// TestIpEx = 2 => L'ip ne doit pas tre ajoute

        if (Conf!=NULL)return;

        if ( NomDestRadio->Checked == true )
        {
                Timer->Enabled = false;
                StatusBar->Panels->Items[0]->Text = "Vrification du destinataire en cours";

                TestIpEx = 2;
                char host[32];
                PHOSTENT name ;

                ICMP->ReceiveTimeout = 3000;

                try
                {
                        ICMP->Host = NomDestEdit->Text;
                        ICMP->Ping();
                        if ( TestIpEx == 0 )
                        {
                                in_addr iaDest;
                                iaDest.s_addr = inet_addr( host );

                                if( iaDest.s_addr == INADDR_NONE )
                                        name = gethostbyname( host );
                                else
                                        name = gethostbyaddr( (const char*)&iaDest, sizeof(struct in_addr), AF_INET );

                                if ( name == NULL )
                                {
                                        StatusBar->Panels->Items[0]->Text = "L'adresse ip n'xiste pas";
                                        MessageBeep( MB_ICONEXCLAMATION );
                                        Timer->Enabled = false;
                                        Timer->Enabled = true;
                                        return;
                                }
                        }
                }
                catch(...)
                {
                        StrPCopy( host, NomDestEdit->Text );

                        in_addr iaDest;
                        iaDest.s_addr = inet_addr( host );

                        if( iaDest.s_addr == INADDR_NONE )
                                name = gethostbyname( host );
                        else
                                name = gethostbyaddr( (const char*)&iaDest, sizeof(struct in_addr), AF_INET );

                        if ( name == 0 )
                        {
                                StatusBar->Panels->Items[0]->Text = "L'adresse ip n'xiste pas";
                                MessageBeep( MB_ICONEXCLAMATION );
                                Timer->Enabled = false;
                                Timer->Enabled = true;
                                return;
                        }
                }
        }
              
        Conf = new TConfirm( NULL );

        ThreadSend = new ThreadSendMsg( false );   // Thread envoi message
        ThreadSend->OnTerminate = FinThreadSendMsg;      // Fin du thread
}
//---------------------------------------------------------------------------

/*********** Anti-Net Send *************/

void __fastcall TH2ONetSender::AntiNetSendClick(TObject *Sender)
{
        FeuxRouge->Visible = false;    //
        FeuxVert->Visible = false;     // Feux Orange pour le traitement
        FeuxOrange->Visible = true;    /////////////////////////////////

        if ( H2OFonctions::IsServiceRunning() == false ) // Si Activer / service arreter
        {
                Timer->Enabled = false;
                StatusBar->Panels->Items[0]->Text = "Dsactivation d'Anti-Net Send en cours";

                WinExec( "net start msg", SW_HIDE );     // on dmarre

                for ( int i = 0; i < 30; i++ )               // tempo avec track bar
                {
                        ProgressBar->Position = i;

                        if ( H2OFonctions::IsServiceRunning() == true )
                                break;

                        Application->ProcessMessages();
                        Sleep( (unsigned long) 300 );
                }
                ProgressBar->Position = 0;

                if ( H2OFonctions::IsServiceRunning() == false ) // re test pour voir si dmarrage effectuer
                {
                        StatusBar->Panels->Items[2]->Text = "Anti-Net Send : ACTIVER";
                        Systray->Hint = "H.2.O Net Sender (Activer)";

                        TMenuItem *ItemToEdit = PopupMenu->Items->Items[4];
                        ItemToEdit->Items[0]->Caption = "Dsactiver";

                        AntiNetSend->Caption = "Dsactiver";
                        AntiNetSend->Hint = "Cliquer pour dsactiver la protection Anti-Net Send (Ctrl+D)";
                        
                        FeuxVert->Visible = false;
                        FeuxRouge->Visible = true;
                        FeuxOrange->Visible = false;
                        
                        StatusBar->Panels->Items[0]->Text = "Prt";

                        Application->MessageBox( "Impossible de dsactiver l'Anti-Net Send (Service de messagerie)\n\nAllez dans : \n\tPanneau de configuration->Outils d'administration->Services\nDans la partie droite slectionne \"Service d'affichage des messages\"\nCliquer droit->Proprits et slectionn dans \n\tType de dmarrage : \"Automatique\"\n", "Erreur", MB_ICONERROR );
                }
                else
                {
                        StatusBar->Panels->Items[2]->Text = "Anti-Net Send : DESACTIVER";
                        Systray->Hint = "H.2.O Net Sender (Dsactiver)";

                        TMenuItem *ItemToEdit = PopupMenu->Items->Items[4];
                        ItemToEdit->Items[0]->Caption = "Activer";

                        AntiNetSend->Caption = "Activer";
                        AntiNetSend->Hint = "Cliquer pour activer la protection Anti-Net Send (Ctrl+A)";
                        FeuxVert->Visible = true;
                        FeuxRouge->Visible = false;
                        FeuxOrange->Visible = false;
                        StatusBar->Panels->Items[0]->Text = "Prt";
                }
        }
        else      // Si dsactiver / service demarrer
        {
                Timer->Enabled = false;
                StatusBar->Panels->Items[0]->Text = "Activation d'Anti-Net Send en cours";

                WinExec( "net stop msg", SW_HIDE );      // On l'arrete

                for ( int i = 0; i < 30; i++ )      // Tempo moin grande 3 sec total
                {
                        ProgressBar->Position = i;

                        if ( H2OFonctions::IsServiceRunning() == false )
                                break;

                        Application->ProcessMessages();
                        Sleep( (unsigned long) 100 );
                }
                ProgressBar->Position = 0;

                if ( H2OFonctions::IsServiceRunning() == false ) // re test pour voir si dmarrage effectuer
                {
                        StatusBar->Panels->Items[2]->Text = "Anti-Net Send : ACTIVER";
                        Systray->Hint = "H.2.O Net Sender (Activer)";

                        TMenuItem *ItemToEdit = PopupMenu->Items->Items[4];
                        ItemToEdit->Items[0]->Caption = "Dsactiver";

                        AntiNetSend->Caption = "Dsactiver";
                        AntiNetSend->Hint = "Cliquer pour dsactiver la protection Anti-Net Send (Ctrl+D)";
                        FeuxVert->Visible = false;
                        FeuxRouge->Visible = true;
                        FeuxOrange->Visible = false;

                        StatusBar->Panels->Items[0]->Text = "Prt";
                }
                else
                {
                        StatusBar->Panels->Items[0]->Text = "Dsactivation impossible";
                        MessageBeep( MB_ICONEXCLAMATION );
                        Timer->Enabled = false;
                        Timer->Enabled = true;

                        StatusBar->Panels->Items[2]->Text = "Anti-Net Send : DESACTIVER";
                        Systray->Hint = "H.2.O Net Sender (Dsactiver)";

                        TMenuItem *ItemToEdit = PopupMenu->Items->Items[4];
                        ItemToEdit->Items[0]->Caption = "Activer";

                        AntiNetSend->Caption = "Activer";
                        AntiNetSend->Hint = "Cliquer pour activer la protection Anti-Net Send (Ctrl+A)";
                        FeuxVert->Visible = true;
                        FeuxRouge->Visible = false;
                        FeuxOrange->Visible = false;
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::CloseNetSendedClick(TObject *Sender)     // Flood erasor
{
        ThreadClose = new CloseNetSend( false );        // Thread Close net send
        ThreadClose->OnTerminate = FinThreadClose;      // Fin du thread
}
//---------------------------------------------------------------------------


// Fonctions complmentaire
///////////////////////////
void __fastcall  TH2ONetSender::FinThreadEnum(TObject *Sender)
{              // Pour finir le thread enumeration
        delete ThreadEnum;
        ThreadEnum = NULL;
}
//---------------------------------------------------------------------------

void __fastcall  TH2ONetSender::FinThreadClose(TObject *Sender)
{              // Pour finir le thread du flood erasor
        delete ThreadClose;
        ThreadClose = NULL;
}
//---------------------------------------------------------------------------

void __fastcall  TH2ONetSender::FinThreadSendMsg(TObject *Sender)
{              // Pour finir le thread d'envoi du message
        delete ThreadSend;
        ThreadSend = NULL;
        Conf = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::FinThreadPrevisualiser(TObject *Sender)
{               // Pour finir le thread d'envoi du message (Prvisualiser)
        delete ThreadPre;
        ThreadPre = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::FinThreadDemarrage(TObject *Sender)
{               // Pour finir le thread de dmarrage
        delete ThreadDem;
        ThreadDem = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::TimerTimer(TObject *Sender)
{              // Timer de 5 secondes pour ractualiser la status bar
        StatusBar->Panels->Items[0]->Text = "Prt";

        if ( H2OFonctions::IsServiceRunning() )
                H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : DESACTIVER";
        else
                H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : ACTIVER";

        Timer->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::ActuTimerTimer(TObject *Sender)
{
        TH2ONetSender::ActualiserClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::ICMPReply(TComponent *ASender,
      const TReplyStatus &AReplyStatus)
{
// TestIpEx = -1 => Valeur par dfaut
// TestIpEx = 0 => Apres ping, l'ip n'exist pas
// TestIpEx = 1 => L'ip doit tre ajoute  la liste si exist o ping
// TestIpEx = 2 => L'ip ne doit pas tre ajoute

        if ( ( AReplyStatus.ReplyStatusType == rsEcho ) && ( TestIpEx == 1 ) )
        {
                // Sauvegarde destinataire
                ////////////////////////////////////////
                        int TestDest = 0;

                        for ( int j = 0; j < 30; j++ )
                        {
                                if ( NomDestRadio->Checked == true )
                                {
                                        if ( NomDestEdit->Text == NomDestEdit->Items->Strings[j] )
                                                TestDest = 1;
                                }
                                if ( NomDestRadio->Checked == false )
                                          TestDest = -1;
                        }
                        if ( TestDest == 0 )
                                NomDestEdit->Items->Insert( 0, NomDestEdit->Text );

                        TIniFile *Ini = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

                        for ( int a = 0; a < 30; a++ )
                                Ini->WriteString( "Save", "Dest" + IntToStr( a ), NomDestEdit->Items->Strings[a] );
                //////////////////////////////////////////////////////////////////////////////////////////////////////////


                // Code vrif dest exist deja ???
                /////////////////////////////////

                bool testExist = false;
                for ( int l = 0; l < DestListe->Count; l++ )
                {
                        if ( NomDestEdit->Text == DestListe->Items->Strings[l] )
                        {
                                testExist = true;
                                break;
                        }
                }
                /////////////////////////////////

                if ( testExist == false )
                {
                        DestListe->Items->Insert( 0, NomDestEdit->Text ); // Ajout sur la pile
                        ListeDestRadio->Checked = true;
                        StatusBar->Panels->Items[0]->Text = "Prt";
                }
                else
                {
                        StatusBar->Panels->Items[0]->Text = "Le destinataire est dj dans la liste";
                        MessageBeep( MB_ICONEXCLAMATION );
                        Timer->Enabled = false;
                        Timer->Enabled = true;
                }
                TestIpEx = -1;
        }
        if ( ( AReplyStatus.ReplyStatusType != rsEcho ) )
        {
                TestIpEx = 0;
                return;
        }
}
//---------------------------------------------------------------------------


// Fentre options
//////////////////

void __fastcall TH2ONetSender::AnnulerOptionsClick(TObject *Sender)
{
        ExpGroupBox->Visible = true;
        DestGroupBox->Visible = true;
        FloodGroupBox->Visible = true;
        InfoGroupBox->Visible = true;
        MessageGroupBox->Visible = true;
        StatusBar->Visible = true;

        for ( float i = 0; i < 450; i = i + 8.98 )
        {
                OptionPanel->Left = i;
                Application->ProcessMessages();
                Sleep( (unsigned long) 5 );
        }
        OptionPanel->Visible = false;
        OptionPanel->Left = 0;

        Image3->Visible = true;
        Image2->Visible = false;

        Application->ProcessMessages();
        
        TIniFile *Ini = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

        Ini->WriteBool( "General", "Open", false );

        delete Ini;
}
//---------------------------------------------------------------------------


// Fenetre APropos
//////////////////

void __fastcall TH2ONetSender::OKButtonClick(TObject *Sender)
{
        for ( float i = 0; i >= -315; i = i - 6.3 )
        {
                AProposPanel->Top = i;
                Application->ProcessMessages();
                Sleep( (unsigned long) 5 );
        }
        AProposPanel->Visible = false;

        TIniFile *Ini = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

        Ini->WriteBool( "APropos", "Open", false );

        delete Ini;

        ExpGroupBox->Enabled = true;
        DestGroupBox->Enabled = true;
        FloodGroupBox->Enabled = true;
        InfoGroupBox->Enabled = true;
        MessageGroupBox->Enabled = true;
        OptionPanel->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::WebSiteClick(TObject *Sender)
{
        ShellExecute(NULL, NULL, "http://nsy.free.fr", NULL, NULL, SW_SHOWNORMAL);
        // Lancement IE pour ouverture page web
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::MailClick(TObject *Sender)
{
        ShellExecute (Handle, "open", "mailto:nsy@free.fr?subject=A propos de H.2.O Net Sender...&body=Votre Message...", 0, 0, SW_SHOWNORMAL);
        // Liens mail sur Nicolas SIMONNY
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::AppliOptionsClick(TObject *Sender)
{
        TIniFile *Options = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

// Group General
////////////////

        // Run Windows
        if ( RunWinCheck->Checked == true )
        {
                Options->WriteBool("General", "RunWin", true );

                TRegistry *RunWin = new TRegistry();

                try
                {
                        RunWin->RootKey = HKEY_LOCAL_MACHINE;
                        if ( RunWin->OpenKey( "Software\\Microsoft\\Windows\\CurrentVersion\\Run", false ) )
                                RunWin->WriteString( "H.2.O Net Sender", ExtractFilePath(Application->ExeName) + "H.2.O Net Sender.exe");
                        else
                        {
                                RunWinCheck->Checked = false;
                                Options->WriteBool("General", "RunWin", false );
                                Application->MessageBox("Impossible d'crire dans la base de registre, dmarrage du programme impossible  l'ouverture de session Windows", "Erreur", MB_ICONEXCLAMATION);
                        }
                }
                catch(...)
                {
                        Options->WriteBool("General", "RunWin", false );
                        Application->MessageBox("Impossible d'crire dans la base de registre, dmarrage du programme impossible  l'ouverture de session Windows", "Erreur", MB_ICONEXCLAMATION);
                        RunWinCheck->Checked = false;
                }

                delete RunWin;
        }
        else
        {
                Options->WriteBool("General", "RunWin", false );

                TRegistry *RunWin = new TRegistry();

                try
                {
                        RunWin->RootKey = HKEY_LOCAL_MACHINE;
                        if ( RunWin->OpenKey( "Software\\Microsoft\\Windows\\CurrentVersion\\Run", false ) )
                                RunWin->DeleteValue( "H.2.O Net Sender" );
                        else
                        {
                                Options->WriteBool("General", "RunWin", false );
                                RunWinCheck->Checked = false;
                        }
                }
                catch(...)
                {
                        Options->WriteBool("General", "RunWin", true );
                        RunWinCheck->Checked = false;
                }

                delete RunWin;
        }

        // Minimizer demarrage
        if ( MiniRunCheck->Checked == true )
                Options->WriteBool("General", "MiniRun", true );
        else
                Options->WriteBool("General", "MiniRun", false );

        // Minimizer a chaque envoi
        if ( MiniSendCheck->Checked == true )
                Options->WriteBool("General", "MiniSend", true );
        else
                Options->WriteBool("General", "MiniSend", false );

        // Effcer apres chaque envoi
        if ( EraseSendCheck->Checked == true )
                Options->WriteBool("General", "EraseSend", true );
        else
                Options->WriteBool("General", "EraseSend", false );

        // Toujour o premier plan
        if ( AllForegroundCheck->Checked == true )
        {
                Options->WriteBool("General", "AllForeground", true );
                H2ONetSender->FormStyle = fsStayOnTop;
        }
        else
        {
                Options->WriteBool("General", "AllForeground", false );
                H2ONetSender->FormStyle = fsNormal;
        }

// Group Historique
///////////////////
        // Sauvegarde message ?
        if ( AlwaysSaveMsgCheck->Checked == true )
                Options->WriteBool("Historique", "Save", true );
        else
                Options->WriteBool("Historique", "Save", false );

        // Limiter taille historique ?                                 // A Voir
        if ( LimitLogCheck->Checked == true )
        {
                Options->WriteInteger("Historique", "Max", StrToInt( MaxListLogCombo->Text ) );
                Options->WriteBool("Historique", "Limit", true );
        }
        else
        {
                Options->WriteInteger("Historique", "Max", StrToInt( MaxListLogCombo->Text ) );
                Options->WriteBool("Historique", "Limit", false );
        }

// Group Liste destinataire
////////////////////////////

        // Actu toutes les ...
        if ( RefreshRadio->Checked == true )
        {
                Options->WriteBool("ListeDest", "Refresh", true );
                Options->WriteInteger("ListeDest", "TimeRefresh", StrToInt( RefreshTimeCombo->Text ) * 60000 );
                ActuTimer->Enabled = false;
                ActuTimer->Interval = 60000 * StrToInt( RefreshTimeCombo->Text );
                ActuTimer->Enabled = true;
        }
        else
        {
                Options->WriteBool("ListeDest", "Refresh", false );
                Options->WriteInteger("ListeDest", "TimeRefresh", StrToInt( RefreshTimeCombo->Text ) * 60000 );
                ActuTimer->Enabled = false;
                ActuTimer->Interval = 60000 * StrToInt( RefreshTimeCombo->Text );
        }

// Group Position
/////////////////
        // Save position or center prog
        if ( CenterRadio->Checked == true )
                Options->WriteBool("General", "Center", true );
        else
                Options->WriteBool("General", "Center", false );

// Group Anti-Net Send
//////////////////////

        // Activer  chaque dmarrage
        if ( ActivANSCheck->Checked == true )
                Options->WriteBool("ANS", "StartWin", true );
        else
                Options->WriteBool("ANS", "StartWin", false );

        // Toujour mettre en pause
        if ( PauseANSCheck->Checked == true )
                Options->WriteBool("ANS", "Pause", true );
        else
                Options->WriteBool("ANS", "Pause", false );

        delete Options;

        TH2ONetSender::AnnulerOptionsClick( Sender );
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::MaxListLogComboKeyPress(TObject *Sender,
      char &Key)
{
        if ( ( Key < 48 || Key > 57 ) && ( Key != VK_BACK ) && ( Key != VK_DELETE ) )
                Key = 0;                 // Impossible d'entree autre chose kun entier
                                         /////////////////////////////////////////////
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::RefreshTimeComboKeyPress(TObject *Sender,
      char &Key)
{
        if ( ( Key < 48 || Key > 57 ) && ( Key != VK_BACK ) && ( Key != VK_DELETE ) )
                Key = 0;                 // Impossible d'entree autre chose kun entier
                                         /////////////////////////////////////////////
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::FormClose(TObject *Sender,
      TCloseAction &Action)
{
        TIniFile *Ini = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

        Ini->WriteInteger( "General", "PosX", Left);
        Ini->WriteInteger( "General", "PosY", Top);
                               // Sauvegarde de la position !!!

        if ( MessageDlg("Etes-vous sr de vouloir quitter ?",mtConfirmation,TMsgDlgButtons() << mbYes << mbNo,0)==mrYes)
            Action = caFree;
        else
            Action = caNone;

        // Flood ?
        //////////
        if(Ini->ReadBool("General","Flood",false))
            Action = caNone;
        //////////

        delete Ini;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Image3MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
      Image4->Visible = true;
      Image3->Visible = false;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
      Image3->Visible = true;
      Image4->Visible = false;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Image2MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
      Image2->Visible = false;
      Image5->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::OptionPanelMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
      Image5->Visible = false;
      Image2->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Image4Click(TObject *Sender)
{
     TH2ONetSender::Options1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Image5Click(TObject *Sender)
{
     TH2ONetSender::AppliOptionsClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::EnvoyerMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
     Envoyer->Caption = ">> Envoyer <<";
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::MessageGroupBoxMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
      Envoyer->Caption = "<< Envoyer >>";
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::GuideRapide1Click(TObject *Sender)
{
     ShellExecute( Handle, "open", "Guide Rapide.chm", 0, 0, SW_SHOWMAXIMIZED );
                      // Affichge fichier aide li
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::GuideRapide2Click(TObject *Sender)
{
     ShellExecute( Handle, "open", "Guide Rapide.chm", 0, 0, SW_SHOWMAXIMIZED );
                      // Affichge fichier aide li
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::AjoutNomListeMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  AjoutNomListe->Visible = false;
  AjoutNomListe1->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::AjoutNomListeMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  AjoutNomListe1->Left++;
  AjoutNomListe1->Top++;
  AjoutNomListe->Visible = false;
  AjoutNomListe1->Visible = true;
}
//---------------------------------------------------------------------------
                                    
void __fastcall TH2ONetSender::AjoutNomListeMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  AjoutNomListe->Visible = true;
  AjoutNomListe1->Visible = false;
  AjoutNomListe1->Left--;
  AjoutNomListe1->Top--;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::DestGroupBoxMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  AjoutNomListe->Visible = true;
  AjoutNomListe1->Visible = false;
  Actualiser->Visible = true;
  Actualiser1->Visible = false;
  SupprElementListe->Visible = true;
  SupprElementListe1->Visible = false;
  Image4->Visible = false;
  Image3->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::SupprElementListeMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  SupprElementListe->Visible = false;
  SupprElementListe1->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::SupprElementListe1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  SupprElementListe1->Left++;
  SupprElementListe1->Top++;
  SupprElementListe->Visible = false;
  SupprElementListe1->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::SupprElementListe1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  SupprElementListe->Visible = true;
  SupprElementListe1->Visible = false;
  SupprElementListe1->Left--;
  SupprElementListe1->Top--;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Actualiser1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
      Actualiser->Visible = true;
      Actualiser1->Visible = false;
      Actualiser1->Left--;
      Actualiser1->Top--;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::Actualiser1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
      Actualiser1->Left++;
      Actualiser1->Top++;
      Actualiser->Visible = false;
      Actualiser1->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::ActualiserMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
      Actualiser->Visible = false;
      Actualiser1->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::LimitLogCheckClick(TObject *Sender)
{
     MaxListLogCombo->Enabled = LimitLogCheck->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::NeverRefreshRadioClick(TObject *Sender)
{
     RefreshTimeCombo->Enabled = !NeverRefreshRadio->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TH2ONetSender::RefreshRadioClick(TObject *Sender)
{
     RefreshTimeCombo->Enabled = RefreshRadio->Checked;
}
//---------------------------------------------------------------------------

