//---------------------------------------------------------------------------

#include <stdio.h>
#include <inifiles.hpp>                 // Pour la gestion des fichier ".ini"
#include <vcl.h>
#pragma hdrstop

#include "H2OFonctions.h"
#include "NetsenderForm.h"
#include "ThreadDemarrage.h"
#pragma package(smart_init)


__fastcall ThreadDemarrage::ThreadDemarrage(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall ThreadDemarrage::Execute()
{
        H2ONetSender->FeuxVert->Visible = false;
        H2ONetSender->FeuxRouge->Visible = false;
        H2ONetSender->FeuxOrange->Visible = true;

        TIniFile *Ini = new TIniFile( ExtractFilePath( Application->ExeName ) + "Options.ini");

        if(Ini->ReadInteger("General","Used",0)<=0)
        {
                if(Application->MessageBox("C'est votre premire utilisation de H.2.O Net Sender 3.1,\n\nVoulez-vous afficher le fichier d'aide du programme et son Guide Rapide ?","H.2.O Net Sender 3.1",MB_YESNO|MB_ICONINFORMATION)==IDYES)
                                ShellExecute( NULL, "open", "Aide H.2.O Net Sender.chm", 0, 0, SW_SHOWMAXIMIZED );
                                    // Affichge fichier aide li
        }
        Ini->WriteInteger("General","Used",Ini->ReadInteger("General","Used",0)+1);

// Minimizer demarrage
        if ( Ini->ReadBool( "General", "MiniRun", false ) == true )
        {
                Application->Minimize();
                H2ONetSender->Systray->Minimize();
        }

// Anti-Net Send : Initialisation

        if ( Ini->ReadBool( "ANS", "StartWin", false ) == true ) // Si Activer / service arreter
        {               // Si service demarrer et necessite de l'eteindre
                  WinExec( "net stop msg", SW_HIDE );      // On l'arrete

                  for ( int i = 0; i < 30; i++ )  // Tempo
                  {
                        if ( H2OFonctions::IsServiceRunning() == false )
                                break;

                        Application->ProcessMessages();
                        Sleep( (unsigned long) 100 );
                  }

                  if ( H2OFonctions::IsServiceRunning() == false ) // re test pour voir si dmarrage effectuer
                  {
                          H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : ACTIVER";
                          H2ONetSender->Systray->Hint = "H.2.O Net Sender (Activer)";

                          TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[4];
                          ItemToEdit->Items[0]->Caption = "Dsactiver";

                          H2ONetSender->AntiNetSend->Caption = "Dsactiver";
                          H2ONetSender->AntiNetSend->Hint = "Cliquer pour dsactiver la protection Anti-Net Send (Ctrl+D)";
                          H2ONetSender->FeuxVert->Visible = false;
                          H2ONetSender->FeuxRouge->Visible = true;
                          H2ONetSender->FeuxOrange->Visible = false;
                  }
                  else
                  {
                          H2ONetSender->Timer->Enabled = false;
                          H2ONetSender->Timer->Enabled = true;
                          H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : DESACTIVER";
                          H2ONetSender->Systray->Hint = "H.2.O Net Sender (Dsactiver)";

                          TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[4];
                          ItemToEdit->Items[0]->Caption = "Activer";

                          H2ONetSender->AntiNetSend->Caption = "Activer";
                          H2ONetSender->AntiNetSend->Hint = "Cliquer pour activer la protection Anti-Net Send (Ctrl+A)";
                          H2ONetSender->FeuxVert->Visible = true;
                          H2ONetSender->FeuxRouge->Visible = false;
                          H2ONetSender->FeuxOrange->Visible = false;

                          Application->MessageBox( "Impossible d'activer l'Anti-Net Send au dmarrage", "Erreur", MB_ICONEXCLAMATION );
                  }
        }
        else      // Si dsactiver / service demarrer
        {
                  WinExec( "net start msg", SW_HIDE );     // on dmarre

                  for ( int i = 0; i < 30; i++ )               // tempo
                  {
                          if ( H2OFonctions::IsServiceRunning() == true )
                                  break;

                          Application->ProcessMessages();
                          Sleep( (unsigned long) 250 );
                  }

                  if ( H2OFonctions::IsServiceRunning() == true )
                  {
                          H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : DESACTIVER";
                          H2ONetSender->Systray->Hint = "H.2.O Net Sender (Dsactiver)";

                          TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[4];
                          ItemToEdit->Items[0]->Caption = "Activer";

                          H2ONetSender->AntiNetSend->Caption = "Activer";
                          H2ONetSender->AntiNetSend->Hint = "Cliquer pour activer la protection Anti-Net Send (Ctrl+A)";
                          H2ONetSender->FeuxVert->Visible = true;
                          H2ONetSender->FeuxRouge->Visible = false;
                          H2ONetSender->FeuxOrange->Visible = false;
                  }
                  else
                  {
                          H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : ACTIVER";
                          H2ONetSender->Systray->Hint = "H.2.O Net Sender (Activer)";

                          TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[4];
                          ItemToEdit->Items[0]->Caption = "Dsactiver";

                          H2ONetSender->AntiNetSend->Caption = "Dsactiver";
                          H2ONetSender->AntiNetSend->Hint = "Cliquer pour dsactiver la protection Anti-Net Send (Ctrl+D)";
                          H2ONetSender->FeuxVert->Visible = false;
                          H2ONetSender->FeuxRouge->Visible = true;

                          H2ONetSender->FeuxOrange->Visible = false;
                          Application->MessageBox( "Impossible de dsactiver l'Anti-Net Send au dmarrage", "Erreur", MB_ICONEXCLAMATION );
                  }
          }
// Fin initialisation anti-net send

        delete Ini;
}
//---------------------------------------------------------------------------
